(* Collie

Ver, 1.00 2005/05/06 芮B
Ver, 1.01 2006/10/28 őOʕ\̒ǉB
Ver, 1.02 2010/03/09 Heeler 薼̕ύXAוύXBDelphi2010 ŃRpCB
          2011/02/18 o[W\[X߂Ă݂B
Ver, 1.10 2012/01/26 OXg̒ǉBDelphiXE2 ŃRpCB
Ver, 1.04 2016/07/28 őSʕ\̔p~Bt@CI[v̒ǉBグo[W߂B
Ver, 1.05 2018/12/02 Delphi10.2 ɈڍsBWin10 ΉBNύXB
Ver, 1.06 2021/03/27 Delphi10.3 ɈڍsBύXB}`j^[΍B

   i{[_[jR[ *)

program Collie;

uses
  Winapi.Windows, System.SysUtils, System.Classes, WndInfo, Winapi.MultiMon, System.Math,
  Winapi.ShellAPI;

{$R *.res}

var
  Excepts: TStrings;
  ProcessID: Cardinal;

function PtOutRect(const Rt: TRect; const Pt: TPoint): Boolean;
begin
  //PtInRect  Right, Bottom dȂĂꍇ͈͊OɂȂB
  //pȂǁÂ߂ɒǉB
  Result := (Pt.X < Rt.Left) or (Rt.Right < Pt.X) or (Pt.Y < Rt.Top) or (Rt.Bottom < Pt.Y);
end;

function EnumWindowsProc(Wnd: HWND; Param: LPARAM): BOOL; stdcall;
var
  ID: Cardinal;
  i: Integer;
  Mon: HMONITOR;
  Info: TMonitorInfo;
  Rt: TRect;
  w, h: Integer;
begin
  Result := True;

  if ProcessID <> 0 then
  begin
    GetWindowThreadProcessId(Wnd, @ID);
    if ID <> ProcessID then
      Exit;
  end;

  for i := 0 to Excepts.Count - 1 do
  begin
    if MatchesWindow(Wnd, Excepts.ValueFromIndex[i], Excepts.Names[i]) then
      Exit;
  end;

  if IsWindowVisible(Wnd) and not IsIconic(Wnd) then
  begin
    Mon := MonitorFromWindow(Wnd, MONITOR_DEFAULTTONEAREST);
    if Mon <> 0 then
    begin
      Info.cbSize := SizeOf(TMonitorInfo);
      if GetMonitorInfo(Mon, @Info) and GetFrameRect(Wnd, Rt) then
      begin
        with Info do
        begin
          if PtOutRect(rcWork, Rt.BottomRight) then
          begin
            w := Rt.Width;
            h := Rt.Height;
            Rt.Right := Min(rcWork.Right, Rt.Right);
            Rt.Bottom := Min(rcWork.Bottom, Rt.Bottom);
            Rt.TopLeft := TPoint.Create(Rt.Right - w, Rt.Bottom - h);
            MoveFrame(Wnd, Rt.Left, Rt.Top, w, h, True);
          end;

          if PtOutRect(rcWork, Rt.TopLeft) then
          begin
            w := Min(rcWork.Width, Rt.Width);
            h := Min(rcWork.Height, Rt.Height);
            Rt.Left := Max(rcWork.Left, Rt.Left);
            Rt.Top := Max(rcWork.Top, Rt.Top);
            MoveFrame(Wnd, Rt.Left, Rt.Top, w, h, True);
          end;
        end;
      end;
    end;
  end;
end;

procedure Execute;
var
  Executes, Temp: TStrings;
  i: Integer;
  Info: TShellExecuteInfo;
begin
  Executes := TStringList.Create;
  try
    i := 1;
    while i <= ParamCount do
    begin
      if CharInSet(ParamStr(i)[1], ['-', '/']) and (Length(ParamStr(i)) = 2) then
      begin
        case ParamStr(i)[2] of
          'E', 'e':
          begin
            Temp := TStringList.Create;
            try
              Temp.LoadFromFile(ParamStr(i + 1));
              Excepts.AddStrings(Temp);
            finally
              Temp.Free;
            end;
            Inc(i);
          end;
        end;
      end
      else
        Executes.Add(ParamStr(i));

      Inc(i);
    end;

    if Executes.Count > 0 then
    begin
      for i := 0 to Executes.Count - 1 do
      begin
        FillChar(Info, SizeOf(TShellExecuteInfo), 0);
        with Info do
        begin
          cbSize := SizeOf(TShellExecuteInfo);
          fMask := SEE_MASK_NOCLOSEPROCESS;
          lpVerb := 'open';
          lpFile := PChar(Executes.Strings[i]);
          lpDirectory := PChar(ExtractFilePath(Executes.Strings[i]));
          nShow := SW_SHOW;
        end;
        if ShellExecuteEx(@Info) then
        begin
          WaitForInputIdle(Info.hProcess, INFINITE);
          ProcessID := GetProcessId(Info.hProcess); //WindowsXP SP1 ȍ~B
          EnumWindows(@EnumWindowsProc, 0);
          CloseHandle(Info.hProcess);
        end;
      end;
    end
    else
    begin
      ProcessID := 0;
      EnumWindows(@EnumWindowsProc, 0);
    end;
  finally
    Executes.Free;
  end;
end;

begin
  {$IFDEF DEBUG}
  ReportMemoryLeaksOnShutdown := True;
  {$ENDIF DEBUG}
  Excepts := TStringList.Create;
  try
    //ȂAZJ_j^[̃^XNo[Ƃ邽߁AɏOݒB
    //Ԗڂ̃^XNo[ 'Shell_SecondaryTrayWnd' ɂȂ̂ŁAChJ[hgpB
    Excepts.Add('=Shell_*TrayWnd');
    Execute;
  finally
    Excepts.Free;
  end;
end.
